% ***********************************************************************
% Copyright (c) Laura Sevilla-Lara and Erik G. Learned-Miller, 2012.
% ***********************************************************************
%%NORMALIZE
function [pts INDX]= findTargetHier(target_models, f2, init_pos, wsize, sp_width, sp_sig, feat_width, feat_sig, nbins,scales,crop_params)

% it returns multiple pts for analysis purpose

%different scales to check at
scalesDist=ones(1,size(scales,2))*10000000;% initialising with large distance

for j=1:size(scales,2)
    % from coarse to fine kernel
    cur_pt = init_pos(j,:);
    pts = cur_pt;
    %crop image according new size
    f21 = f2(crop_params(j,1):crop_params(j,1)+crop_params(j,3)-1, crop_params(j,2):crop_params(j,2)+crop_params(j,4)-1);
%    im = uint8(drawRect(f2,[crop_params(j,1) crop_params(j,2)] , [crop_params(j,3) crop_params(j,4)], 'r', 1));
%    im = uint8(drawRect(im,crop_params(j,[1 2])+init_pos(j,:) , wsize, 'g', 1));
%    %save(sprintf('%s.png',num2str(j)),uint8(f21));
%     imshow(im);
%     pause(0.1);
    df2 = img2df(double(f21), nbins);
    %resize all the Target DF
    for p=1:size(target_models,2)
%         if(scales(j)==1)
%             continue;
%         end
        for k=1:size(target_models{1},3)
           re_target_models{p,j}(:,:,k)=imresize(target_models{p}(:,:,k),scales(j));
        end     
    end
    
    for i=length(sp_width):-1:1
        % explode and convolve 
        df2_s = smoothDF(df2, [sp_width(i), feat_width], [sp_sig(i), feat_sig]);
        % find target
        [cur_pt X] = findTarget(re_target_models{i,j}(:,:,:), df2_s, cur_pt, size(re_target_models{i,j}(:,:,1)));%round(wsize*scales(j))); 
        
        pts = [pts; cur_pt];
        
    end;
    scalesDist(j)=X;%already normalised(scales(j)*scales(j)*size(re_target_models{i,j}(:,:,1),1)*size(re_target_models{i,j}(:,:,1),2));
    
end
[minDist indx]=min(scalesDist);
INDX=indx;

